'''
Night Elf WCS:Python Race Coded By: J3ff Hoogland
'''
import wcs, es, random, NightElfConfig, playerlib
from wcs import wcs
from NightElfConfig import *
#Our Race's Name - This is not needed I just feel it makes things look cleaner
RaceName = 'Night Elf'
wcs.Race(RaceName).registerSkill('Evasion', Evasion_MaxRanks, Evasion_LevelInterval, 'Have a chance to dodge damage from an attack.')
wcs.Race(RaceName).registerSkill('Thorns', Thorns_MaxRanks, Thorns_LevelInterval, 'Have a chance to reflect 30% damage back at your attacker.')
wcs.Race(RaceName).registerSkill('True Shot', TrueShot_MaxRanks, TrueShot_LevelInterval, 'Have a 30% change to deal bonus damage.')
wcs.Race(RaceName).registerUltimate('Entangle', Entangle_RequiredLevel, Entangle_MaxRanks, Entangle_LevelInterval, 'Use your ultimate to stop all nearby enemies from moving.')
def player_hurt(event_var):
	userid = int(event_var['userid'])
	attacker = int(event_var['attacker'])
	if attacker:
		if event_var['dmg_health']:
			damage = int(event_var['dmg_health'])
		else:
			damage = 0
		thorns = wcs.GetLevel(userid, RaceName, 'Thorns')*Thorns_Percent
		if thorns:
			if random.randint(1,100) <= thorns:
				wcs.Command(attacker).Damage(damage*.3,32,userid)
				es.tell(userid, '#multi', '#lightgreenThorns #default- #greenYou have returned %s damage to %s.'%(damage*.3,event_var['es_attackername']))
				wcs.Effect().Beam1(userid, attacker, 1.5, 0, 255, 0)
		trueshot = wcs.GetLevel(attacker, RaceName, 'True Shot') * (TrueShot_Percent*.01)
		if trueshot:
			if random.randint(1,100) <= 30:
				wcs.Command(userid).Damage(damage*trueshot,32,attacker)
				es.tell(attacker, '#multi', '#lightgreenTrue Shot #default- #greenYou have dealt %s extra damage.'%(damage*trueshot))
				wcs.Effect().Beam2(attacker, userid, 1.5, 0, 200, 150)
def prep_hurt(event_var):
	userid = int(event_var['userid'])
	attacker = int(event_var['attacker'])
	if attacker:
		damage = int(event_var['dmg_health'])
		evasion = wcs.GetLevel(userid, RaceName, 'Evasion') * Evasion_Percent 
		if evasion:
			if evasion >= random.randint(1,100):
				wcs.Command(userid).SaveLife(damage)
				es.tell(userid, '#multi', '#lightgreenEvasion #default- #greenYou have dodged %s damage from an attack.'%damage)
def player_ultimate_on(event_var):
	userid = int(event_var['userid'])
	team = int(es.getplayerteam(userid))
	if team == 2:
		filter = '#ct'
	elif team == 3:
		filter = '#t'
	entangle = wcs.GetLevel(userid, RaceName, 'Entangle')
	if entangle:
		wcs.Command(userid).Near(640,stun,filter)
		wcs.Command(userid).SetCoolDown('Entangle',Entangle_CoolDownTimer)
def stun(userid, attacker):
	wcs.Command(userid).Freeze(wcs.GetLevel(attacker, RaceName, 'Entangle')*Entangle_Duration)
	wcs.Effect().Beam2(attacker, userid, 1.5, 0, 255, 0)
	es.tell(userid, '#lightgreen', 'You have been entangled!')